Package net.sf.saxon.value

## Class YearMonthDurationValue

- java.lang.Object
- - net.sf.saxon.value.AtomicValue
  - - net.sf.saxon.value.DurationValue
    - - net.sf.saxon.value.YearMonthDurationValue

- All Implemented Interfaces:
    `java.lang.Comparable<YearMonthDurationValue>`, `java.lang.Iterable<AtomicValue>`, `AtomicMatchKey`, `AtomicSequence`, `GroundedValue`, `IdentityComparable`, `Item`, `Sequence`, `ConversionResult`

      public final class YearMonthDurationValue
      extends DurationValue
      implements java.lang.Comparable<YearMonthDurationValue>

  A value of type xs:yearMonthDuration.

  The state retained by this class is essentially a signed 32-bit integer representing the number of months: that is, `year*12 + month`; plus a type label allowing subtypes of `xs:yearMonthDuration` to be represented.

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.value.DurationValue

      `months, nanoseconds, negative, seconds`

    - ### Fields inherited from class net.sf.saxon.value.AtomicValue

      `typeLabel`

    - ### Fields inherited from interface net.sf.saxon.expr.sort.AtomicMatchKey

      `NaN_MATCH_KEY`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `DurationValue` | `add​(DurationValue other)` | Add two year-month-durations
    `int` | `compareTo​(YearMonthDurationValue other)` | Compare the value to another duration value
    `AtomicValue` | `copyAsSubType​(AtomicType typeLabel)` | Create a copy of this atomic value, with a different type label
    `DurationValue` | `divide​(double n)` | Divide duration by a number.
    `BigDecimalValue` | `divide​(DurationValue other)` | Find the ratio between two durations
    `static YearMonthDurationValue` | `fromMonths​(int months)` | Construct a duration value as a number of months.
    `int` | `getLengthInMonths()` | Get the number of months in the duration
    `java.lang.CharSequence` | `getPrimitiveStringValue()` | Convert to string
    `BuiltInAtomicType` | `getPrimitiveType()` | Determine the primitive type of the value.
    `AtomicMatchKey` | `getXPathComparable​(boolean ordered, StringCollator collator, int implicitTimezone)` | Get a Comparable value that implements the XPath ordering comparison semantics for this value.
    `static ConversionResult` | `makeYearMonthDurationValue​(java.lang.CharSequence s)` | Static factory: create a year-month duration value from a supplied string, in ISO 8601 format [+|-]PnYnM
    `YearMonthDurationValue` | `multiply​(double n)` | Multiply duration by a number.
    `YearMonthDurationValue` | `multiply​(long factor)` | Multiply a duration by an integer
    `DurationValue` | `negate()` | Negate a duration (same as subtracting from zero, but it preserves the type of the original duration)
    `DurationValue` | `subtract​(DurationValue other)` | Subtract two year-month-durations

    - ### Methods inherited from class net.sf.saxon.value.DurationValue

      `badDuration, badDuration, equals, formatFractionalSeconds, getComponent, getDays, getHours, getLengthInSeconds, getMicroseconds, getMinutes, getMonths, getNanoseconds, getSchemaComparable, getSchemaComparable, getSeconds, getTotalMonths, getTotalSeconds, getYears, hashCode, makeDuration, makeDuration, normalizeZeroDuration, signum, simpleInteger`

    - ### Methods inherited from class net.sf.saxon.value.AtomicValue

      `asAtomic, asMapKey, atomize, checkPermittedContents, checkValidInJavascript, effectiveBooleanValue, getCanonicalLexicalRepresentation, getCardinality, getGenre, getItemType, getLength, getStringValue, getStringValueCS, getUType, head, identityHashCode, isIdentical, isIdentical, isNaN, itemAt, iterate, iterator, setTypeLabel, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.expr.sort.AtomicMatchKey

      `asAtomic`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, materialize`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `isStreamed, reduce, subsequence, toShortString`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

- - ### Method Detail

    - #### makeYearMonthDurationValue

          public static ConversionResult makeYearMonthDurationValue​(java.lang.CharSequence s)

      Static factory: create a year-month duration value from a supplied string, in ISO 8601 format [+|-]PnYnM
      Parameters:
        `s` - a string in the lexical space of xs:yearMonthDuration.
      Returns:
        either a YearMonthDurationValue, or a ValidationFailure if the string was not in the lexical space of xs:yearMonthDuration.

    - #### copyAsSubType

          public AtomicValue copyAsSubType​(AtomicType typeLabel)

      Create a copy of this atomic value, with a different type label
      Overrides:
        `copyAsSubType` in class `DurationValue`
      Parameters:
        `typeLabel` - the type label of the new copy. The caller is responsible for checking that the value actually conforms to this type.
      Returns:
        the copied value

    - #### getPrimitiveType

          public BuiltInAtomicType getPrimitiveType()

      Determine the primitive type of the value. This delivers the same answer as getItemType().getPrimitiveItemType(). The primitive types are the 19 primitive types of XML Schema, plus xs:integer, xs:dayTimeDuration and xs:yearMonthDuration, and xs:untypedAtomic. For external objects, the result is AnyAtomicType.
      Overrides:
        `getPrimitiveType` in class `DurationValue`
      Returns:
        the primitive type

    - #### getPrimitiveStringValue

          public java.lang.CharSequence getPrimitiveStringValue()

      Convert to string
      Overrides:
        `getPrimitiveStringValue` in class `DurationValue`
      Returns:
        ISO 8601 representation.

    - #### getLengthInMonths

          public int getLengthInMonths()

      Get the number of months in the duration
      Returns:
        the number of months in the duration

    - #### fromMonths

          public static YearMonthDurationValue fromMonths​(int months)

      Construct a duration value as a number of months.
      Parameters:
        `months` - the number of months (may be negative)
      Returns:
        the corresponding xs:yearMonthDuration value

    - #### multiply

          public YearMonthDurationValue multiply​(long factor)
                                          throws XPathException

      Multiply a duration by an integer
      Overrides:
        `multiply` in class `DurationValue`
      Parameters:
        `factor` - the number to multiply by
      Returns:
        the result of the multiplication
      Throws:
        `XPathException`

    - #### multiply

          public YearMonthDurationValue multiply​(double n)
                                          throws XPathException

      Multiply duration by a number.
      Overrides:
        `multiply` in class `DurationValue`
      Parameters:
        `n` - the number to multiply by
      Returns:
        the result of the multiplication
      Throws:
        `XPathException`

    - #### divide

          public DurationValue divide​(double n)
                               throws XPathException

      Divide duration by a number.
      Overrides:
        `divide` in class `DurationValue`
      Parameters:
        `n` - the number to divide by
      Returns:
        the result of the division
      Throws:
        `XPathException`

    - #### divide

          public BigDecimalValue divide​(DurationValue other)
                                 throws XPathException

      Find the ratio between two durations
      Overrides:
        `divide` in class `DurationValue`
      Parameters:
        `other` - the dividend
      Returns:
        the ratio, as a decimal
      Throws:
        `XPathException` - if an error occurs, for example division by zero or dividing durations of different type

    - #### add

          public DurationValue add​(DurationValue other)
                            throws XPathException

      Add two year-month-durations
      Overrides:
        `add` in class `DurationValue`
      Parameters:
        `other` - the duration to be added to this one
      Returns:
        the sum of the two durations
      Throws:
        `XPathException`

    - #### subtract

          public DurationValue subtract​(DurationValue other)
                                 throws XPathException

      Subtract two year-month-durations
      Overrides:
        `subtract` in class `DurationValue`
      Parameters:
        `other` - the duration to be subtracted from this one
      Returns:
        the difference of the two durations
      Throws:
        `XPathException`

    - #### negate

          public DurationValue negate()

      Negate a duration (same as subtracting from zero, but it preserves the type of the original duration)
      Overrides:
        `negate` in class `DurationValue`
      Returns:
        the original duration with its sign reversed, retaining its type

    - #### compareTo

          public int compareTo​(YearMonthDurationValue other)

      Compare the value to another duration value
      Specified by:
        `compareTo` in interface `java.lang.Comparable<YearMonthDurationValue>`
      Parameters:
        `other` - The other dateTime value
      Returns:
        negative value if this one is the earler, 0 if they are chronologically equal, positive value if this one is the later. For this purpose, dateTime values with an unknown timezone are considered to be UTC values (the Comparable interface requires a total ordering).
      Throws:
        `java.lang.ClassCastException` - if the other value is not a DateTimeValue (the parameter is declared as Object to satisfy the Comparable interface)

    - #### getXPathComparable

          public AtomicMatchKey getXPathComparable​(boolean ordered,
                                                   StringCollator collator,
                                                   int implicitTimezone)

      Get a Comparable value that implements the XPath ordering comparison semantics for this value. Returns null if the value is not comparable according to XPath rules. The default implementation returns the value itself. This is modified for types such as xs:duration which allow ordering comparisons in XML Schema, but not in XPath.
      Overrides:
        `getXPathComparable` in class `DurationValue`
      Parameters:
        `ordered` - true if ordered comparisons need to be supported
        `collator` - for comparing strings - not used
        `implicitTimezone` - implicit timezone in the dynamic context - not used
      Returns:
        an Object whose equals() and hashCode() methods implement the XPath comparison semantics with respect to this atomic value. If ordered is specified, the result will either be null if no ordering is defined, or will be a Comparable